# coding:utf-8
# encoding.rb
# 内容 :外部エンコーディングと内部エンコーディングとの使用例
# 前提 :スクリプトはutf-8、入出力ファイルはshift_jis
# Copyright (c) 2011-2015 Mitsuo Minagawa, All rights reserved.
# (minagawa@fb3.so-net.ne.jp)
# 使用方法 : c:\>ruby encoding.rb

# 入力ファイルはshift_jis、内部の文字コードはutf-8
in1_file	=	open("input_sjis.txt","r:shift_jis:utf-8")
# 出力ファイルはshift_jis、内部の文字コードはutf-8
# (内部の文字コードはutf-8からshift_jisに変換して出力する)
out1_file	=	open("output.txt","w:shift_jis:utf-8")

# 主処理
while	(line1	=	in1_file.gets)
	line1.chomp!
#タブ区切りのとき
#				in1		=	line1.split("\t",-1)
#カンマ区切りのとき
	in1	=	(line1 + ',')
			.scan(/"([^"\\]*(?:\\.[^"\\]*)*)",|([^,]*),/)
			.collect{|x,y| y || x.gsub(/(.)/, '\1')}

	if		(/表/	=~	in1[2])
			in1[1]		=	"XYZ"
	elsif		(/機/	=~	in1[2])
			in1[1]		=	"PQR"
	end

	out1	=	in1.join("\t")
	out1_file.print	out1,"\n"
end	

# ファイルのクローズ
in1_file.close
out1_file.close
