# coding:windows-31j
# zenhanconv.rb
# e : SpJ^JiƑSpASpAt@xbgꂼ
#        pJ^JiƔpApAt@xbgɕϊB
#        (L̋tϊs)
# O : ruby1.9ȏł邱
#        ̓t@CƃXNvg͗Ƃshift_jisƂ邱
# Copyright (c) 2011-2015 Mitsuo Minagawa, All rights reserved.
# (minagawa@fb3.so-net.ne.jp)
# gp@ : c:\>ruby zenhanconv.rb
#

# ̓t@C
in1_file	=	open("input_sjis.txt","r:windows-31j")
# o̓t@C
out1_file	=	open("output_sjis.txt","w:windows-31j")

class	ZenHankakuConvert
	@@zen_kana = %w(K M O Q S U W Y [ ]
                    _ a d f h o r u x { p s v y | 
                    A C E G I J L N P R T V X Z \
                    ^ ` c e g i j k l m n q t w z
                    } ~              
                       @ B D F H b J K [ E ).freeze
	@@han_kana = %w(         
                                   
                                  
                                  
                                   
                                 ).freeze
	@@zen_number	=	%w(O P Q R S T U V W X ).freeze
	@@han_number	=	%w(0 1 2 3 4 5 6 7 8 9 ).freeze
	@@zen_alpha		=	%w(            
                                       
                           ` a b c d e f g h i j k l
                           m n o p q r s t u v w x y ).freeze
	@@han_alpha		=	%w(a b c d e f g h i j k l m
                           n o p q r s t u v w x y z
                           A B C D E F G H I J K L M
                           N O P Q R S T U V W X Y Z ).freeze

	def	z2h(str)
		convert(str, @@zen_kana, @@han_kana)
		convert(str, @@zen_number, @@han_number)
		convert(str, @@zen_alpha, @@han_alpha)
	end

	def	h2z(str)
		convert(str, @@han_kana, @@zen_kana)
		convert(str, @@han_number, @@zen_number)
		convert(str, @@han_alpha, @@zen_alpha)
	end

private
	def	convert(str, from, to)
		from.each_with_index	do	|char, i|
			str.gsub!(char, to[i])
		end

		return	str
	end
end

require 'nkf'

s_zenhan	=	ZenHankakuConvert.new

# 又
while	(line1	=	in1_file.gets)
	line1.chomp!
#^u؂̂Ƃ
#	in1		=	line1.split("\t",-1)
#J}؂̂Ƃ
	in1		=	(line1 + ',')
				.scan(/"([^"\\]*(?:\\.[^"\\]*)*)",|([^,]*),/)
				.collect{|x,y| y || x.gsub(/(.)/, '\1')}

# Sp甼p֕ϊ
	in1[2]	=	s_zenhan.z2h(in1[2])
# pSp֕ϊ
#	in1[2]	=	s_zenhan.h2z(in1[2])
	out1	=	in1.join("\t")
	out1_file.print	out1,"\n"

end

# t@C̃N[Y
in1_file.close
out1_file.close
